<template>
    <div v-if="address" class="root" :class="{'vertical': orientation === 'vertical', 'horizontal': orientation === 'horizontal'}">
        <div>
            <span
              class="title"
              :class="{
                default: titleSize === 'default',
                large: titleSize === 'large',
                xLarge: titleSize === 'xLarge',
              }"
            >
              Address:
            </span>
        </div>
        <div class="address-display">
            <input
                type="text"
                class="key text-truncate d-inline-block border-0 p-0 w-100"
                :class="{'vertical': orientation === 'vertical', 'horizontal': orientation === 'horizontal'}"
                id="popUpClipboardContent"
                v-on:click.prevent="copyWalletAddress($event)"
                data-toggle="tooltip"
                data-placement="bottom"
                readonly
                v-bind:value="userDetails.address"
            />
        </div>
    </div>
  <div v-else>{{ addressNotFoundPlaceholder }}</div>
</template>

<script lang="ts">
import { Component, Prop } from "vue-property-decorator";
import { mixins } from "vue-class-component";

import CopyToClipboard from "@/mixins/CopyToClipboard";
import StoreModules from "@/mixins/StoreModules";
import ColoredCircle from "@/components/bricks/ColoredCircle.vue";
import displayMessages from "@/constants/displayMessages";
import { loggerMessage } from "@/constants/logger";

@Component({
  components: {
    ColoredCircle
  }
})
export default class WalletAddressDisplay extends mixins(
  CopyToClipboard,
  StoreModules
) {
  @Prop({ default: "vertical" }) public readonly orientation!:
    | "horizontal"
    | "vertical";
  @Prop({ default: "default" }) public readonly titleSize!:
    | "default"
    | "large"
    | "xLarge";

  get userDetails() {
    return this.userModule.userDetails;
  }

  get address() {
    return !this.userDetails.address ? "" : this.userDetails.address;
  }

  get addressNotFoundPlaceholder() {
    return displayMessages.ADDRESS_NOT_FOUND;
  }

  public copyWalletAddress(event: MouseEvent) {
    this.copyToClipboard(
      event.target,
      displayMessages.PUBLIC_ADDRESS_COPIED,
      loggerMessage.PUBLIC_ADDRESS_COPIED,
      loggerMessage.PUBLIC_ADDRESS_COPYING_FAILED
    );
  }
}
</script>

<style lang="scss" scoped>
.root {
    box-sizing: border-box;
    display: flex;
    width: 100%;

  &.vertical {
    flex-direction: column;
  }

  &.horizontal {
    flex-direction: row;
  }
}

.address-display {
    width: 100%;

  .vertical {
    margin-top: .5rem;
  }

  .horizontal {
    margin-left: .5rem;
  }
}

.title {
  margin: 0;

  &.default {
    font-size: $baseFontSize;
  }

  &.large {
    font-size: $h2Size;
  }

  &.xLarge {
    font-size: $h1Size;
  }
}
</style>
